import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
public class NB {
	// Number of Categories
	int NC = 2;
	// Number of Variables
	int NV;
	// Leaning Data
	ArrayList<int[]> LD;
	// Test Data
	ArrayList<int[]> TD;
	//頻度表
	double[] ft_c;
	ArrayList<double[][]> ft_ic;
	public NB() throws IOException{
		//データセット入力
		String dataset = "spam";
		System.out.println("Dataset: "+dataset);
		//学習データ読み込み
		readLearningData("data/"+dataset+"/LD.csv");
		//頻度表の生成
		setFrequencyTable();
		//テストデータ読み込み
		readTestingData("data/"+dataset+"/TD.csv");
		//NBのパラメータ学習
		ArrayList<HashMap<Integer, Double>> parameters = getParameters();
		//学習したNBでテストデータを分類
		classification(parameters);
	}

	// 変数自身とその親の値を鍵としてその条件付き確率パラメータを返すようなHashMapを，各変数ごとにArrayListで繋いだものを返す関数
	private ArrayList<HashMap<Integer, Double>> getParameters(){






	}

	//パラメータを用いてテストデータの分類をし，その正答率を表示する．
	private void classification(ArrayList<HashMap<Integer, Double>> parameters){
		double num_correct_prediction = 0;
		for(int d = 0; d < TD.size(); ++d){






			//正答回数測定
			if(predictedClass == TD.get(d)[NV - 1]){
				num_correct_prediction++;
			}
		}
		//正答率表示
		System.out.println("Classification accuracy: "+num_correct_prediction / (double)TD.size());
	}

	// 訓練データ読み込み
	private void readLearningData(String DataBaseName) throws IOException{
		BufferedReader br = new BufferedReader(new FileReader(new File(DataBaseName)));
		ArrayList<String[]> tLD = new ArrayList<String[]>();
		String line = br.readLine();
		NV = line.split(",").length;
		while(line != null){
			String[] data = line.split(",").clone();
			tLD.add(data);
			line = br.readLine();
		}
		LD = new ArrayList<int[]>();
		for(int i = 0; i < tLD.size(); ++i){
			LD.add(new int[NV]);
			for(int j = 0; j < NV; ++j){
				LD.get(i)[j] = Integer.parseInt(tLD.get(i)[j]);
			}
		}
		br.close();
	}

	// テストデータ読み込み
	private void readTestingData(String DataBaseName) throws IOException{
		BufferedReader br = new BufferedReader(new FileReader(new File(DataBaseName)));
		ArrayList<String[]> tTD = new ArrayList<String[]>();
		String line = br.readLine();
		while(line != null){
			String[] data = line.split(",").clone();
			tTD.add(data);
			line = br.readLine();
		}
		TD = new ArrayList<int[]>();
		for(int i = 0; i < tTD.size(); ++i){
			TD.add(new int[NV]);
			for(int j = 0; j < NV; ++j){
				TD.get(i)[j] = Integer.parseInt(tTD.get(i)[j]);
			}
		}
		br.close();
	}

	//N_{x_0}とN_{i x_0 k}をそれぞれft_c，ft_icに格納する関数
	private void setFrequencyTable(){
		//初期化
		ft_c = new double[NC];
		ft_ic = new ArrayList<>();
		for(int i = 0; i < NV - 1; ++i){
			ft_ic.add(new double[NC][NC]);
		}
		//ft_c, ft_icを計算
		for(int d = 0; d < LD.size(); ++d){






		}
	}

	public static void main(String[] args) throws IOException {
		new NB();
	}
}
